MODULE Graphics;

IMPORT
  SYSTEM, W := Windows, Cl := Classes;

CONST
  fsBold*      = 1;
  fsItalic*    = 2;
  fsUnderline* = 3;
  fsStrikeOut* = 4;

  clBlack*                         = 0000000H;
  clMaroon*                        = 0000080H;
  clGreen*                         = 0008000H;
  clOlive*                         = 0008080H;
  clNavy*                          = 0800000H;
  clPurple*                        = 0800080H;
  clTeal*                          = 0808000H;
  clGray*                          = 0808080H;
  clSilver*                        = 0C0C0C0H;
  clRed*                           = 00000FFH;
  clLime*                          = 000FF00H;
  clYellow*                        = 000FFFFH;
  clBlue*                          = 0FF0000H;
  clFuchsia*                       = 0FF00FFH;
  clAqua*                          = 0FFFF00H;
  clLtGray*                        = 0C0C0C0H;
  clDkGray*                        = 0808080H;
  clWhite*                         = 0FFFFFFH;
  StandardColorsCount*             = 16;

  clMoneyGreen*                    = 0C0DCC0H;
  clSkyBlue*                       = 0F0CAA6H;
  clCream*                         = 0F0FBFFH;
  clMedGray*                       = 0A4A0A0H;
  ExtendedColorsCount*             = 4;

  clNone*                          = 01FFFFFFFH;
  clDefault*                       = 020000000H;

  clWebSnow*                       = 0FAFAFFH;
  clWebFloralWhite*                = 0F0FAFFH;
  clWebLavenderBlush*              = 0F5F0FFH;
  clWebOldLace*                    = 0E6F5FDH;
  clWebIvory*                      = 0F0FFFFH;
  clWebCornSilk*                   = 0DCF8FFH;
  clWebBeige*                      = 0DCF5F5H;
  clWebAntiqueWhite*               = 0D7EBFAH;
  clWebWheat*                      = 0B3DEF5H;
  clWebAliceBlue*                  = 0FFF8F0H;
  clWebGhostWhite*                 = 0FFF8F8H;
  clWebLavender*                   = 0FAE6E6H;
  clWebSeashell*                   = 0EEF5FFH;
  clWebLightYellow*                = 0E0FFFFH;
  clWebPapayaWhip*                 = 0D5EFFFH;
  clWebNavajoWhite*                = 0ADDEFFH;
  clWebMoccasin*                   = 0B5E4FFH;
  clWebBurlywood*                  = 087B8DEH;
  clWebAzure*                      = 0FFFFF0H;
  clWebMintcream*                  = 0FAFFF5H;
  clWebHoneydew*                   = 0F0FFF0H;
  clWebLinen*                      = 0E6F0FAH;
  clWebLemonChiffon*               = 0CDFAFFH;
  clWebBlanchedAlmond*             = 0CDEBFFH;
  clWebBisque*                     = 0C4E4FFH;
  clWebPeachPuff*                  = 0B9DAFFH;
  clWebTan*                        = 08CB4D2H;

  clWebYellow*                     = 000FFFFH;
  clWebDarkOrange*                 = 0008CFFH;
  clWebRed*                        = 00000FFH;
  clWebDarkRed*                    = 000008BH;
  clWebMaroon*                     = 0000080H;
  clWebIndianRed*                  = 05C5CCDH;
  clWebSalmon*                     = 07280FAH;
  clWebCoral*                      = 0507FFFH;
  clWebGold*                       = 000D7FFH;
  clWebTomato*                     = 04763FFH;
  clWebCrimson*                    = 03C14DCH;
  clWebBrown*                      = 02A2AA5H;
  clWebChocolate*                  = 01E69D2H;
  clWebSandyBrown*                 = 060A4F4H;
  clWebLightSalmon*                = 07AA0FFH;
  clWebLightCoral*                 = 08080F0H;
  clWebOrange*                     = 000A5FFH;
  clWebOrangeRed*                  = 00045FFH;
  clWebFirebrick*                  = 02222B2H;
  clWebSaddleBrown*                = 013458BH;
  clWebSienna*                     = 02D52A0H;
  clWebPeru*                       = 03F85CDH;
  clWebDarkSalmon*                 = 07A96E9H;
  clWebRosyBrown*                  = 08F8FBCH;

  clWebPaleGoldenrod*              = 0AAE8EEH;
  clWebLightGoldenrodYellow*       = 0D2FAFAH;
  clWebOlive*                      = 0008080H;
  clWebForestGreen*                = 0228B22H;
  clWebGreenYellow*                = 02FFFADH;
  clWebChartreuse*                 = 000FF7FH;
  clWebLightGreen*                 = 090EE90H;
  clWebAquamarine*                 = 0D4FF7FH;
  clWebSeaGreen*                   = 0578B2EH;
  clWebGoldenRod*                  = 020A5DAH;
  clWebKhaki*                      = 08CE6F0H;
  clWebOliveDrab*                  = 0238E6BH;
  clWebGreen*                      = 0008000H;
  clWebYellowGreen*                = 032CD9AH;
  clWebLawnGreen*                  = 000FC7CH;
  clWebPaleGreen*                  = 098FB98H;
  clWebMediumAquamarine*           = 0AACD66H;
  clWebMediumSeaGreen*             = 071B33CH;
  clWebDarkGoldenRod*              = 00B86B8H;
  clWebDarkKhaki*                  = 06BB7BDH;
  clWebDarkOliveGreen*             = 02F6B55H;
  clWebDarkgreen*                  = 0006400H;
  clWebLimeGreen*                  = 032CD32H;
  clWebLime*                       = 000FF00H;
  clWebSpringGreen*                = 07FFF00H;
  clWebMediumSpringGreen*          = 09AFA00H;
  clWebDarkSeaGreen*               = 08FBC8FH;

  clWebLightSeaGreen*              = 0AAB220H;
  clWebPaleTurquoise*              = 0EEEEAFH;
  clWebLightCyan*                  = 0FFFFE0H;
  clWebLightBlue*                  = 0E6D8ADH;
  clWebLightSkyBlue*               = 0FACE87H;
  clWebCornFlowerBlue*             = 0ED9564H;
  clWebDarkBlue*                   = 08B0000H;
  clWebIndigo*                     = 082004BH;
  clWebMediumTurquoise*            = 0CCD148H;
  clWebTurquoise*                  = 0D0E040H;
  clWebCyan*                       = 0FFFF00H;
  clWebAqua*                       = 0FFFF00H;
  clWebPowderBlue*                 = 0E6E0B0H;
  clWebSkyBlue*                    = 0EBCE87H;
  clWebRoyalBlue*                  = 0E16941H;
  clWebMediumBlue*                 = 0CD0000H;
  clWebMidnightBlue*               = 0701919H;
  clWebDarkTurquoise*              = 0D1CE00H;
  clWebCadetBlue*                  = 0A09E5FH;
  clWebDarkCyan*                   = 08B8B00H;
  clWebTeal*                       = 0808000H;
  clWebDeepskyBlue*                = 0FFBF00H;
  clWebDodgerBlue*                 = 0FF901EH;
  clWebBlue*                       = 0FF0000H;
  clWebNavy*                       = 0800000H;

  clWebDarkViolet*                 = 0D30094H;
  clWebDarkOrchid*                 = 0CC3299H;
  clWebMagenta*                    = 0FF00FFH;
  clWebFuchsia*                    = 0FF00FFH;
  clWebDarkMagenta*                = 08B008BH;
  clWebMediumVioletRed*            = 08515C7H;
  clWebPaleVioletRed*              = 09370DBH;
  clWebBlueViolet*                 = 0E22B8AH;
  clWebMediumOrchid*               = 0D355BAH;
  clWebMediumPurple*               = 0DB7093H;
  clWebPurple*                     = 0800080H;
  clWebDeepPink*                   = 09314FFH;
  clWebLightPink*                  = 0C1B6FFH;
  clWebViolet*                     = 0EE82EEH;
  clWebOrchid*                     = 0D670DAH;
  clWebPlum*                       = 0DDA0DDH;
  clWebThistle*                    = 0D8BFD8H;
  clWebHotPink*                    = 0B469FFH;
  clWebPink*                       = 0CBC0FFH;

  clWebLightSteelBlue*             = 0DEC4B0H;
  clWebMediumSlateBlue*            = 0EE687BH;
  clWebLightSlateGray*             = 0998877H;
  clWebWhite*                      = 0FFFFFFH;
  clWebLightgrey*                  = 0D3D3D3H;
  clWebGray*                       = 0808080H;
  clWebSteelBlue*                  = 0B48246H;
  clWebSlateBlue*                  = 0CD5A6AH;
  clWebSlateGray*                  = 0908070H;
  clWebWhiteSmoke*                 = 0F5F5F5H;
  clWebSilver*                     = 0C0C0C0H;
  clWebDimGray*                    = 0696969H;
  clWebMistyRose*                  = 0E1E4FFH;
  clWebDarkSlateBlue*              = 08B3D48H;
  clWebDarkSlategray*              = 04F4F2FH;
  clWebGainsboro*                  = 0DCDCDCH;
  clWebDarkGray*                   = 0A9A9A9H;
  clWebBlack*                      = 0000000H;

VAR
  clSystemColor*,clScrollBar*,clBackground*,clActiveCaption*,
  clInactiveCaption*,clMenu*,clWindow*,clWindowFrame*,clMenuText*,
  clWindowText*,clCaptionText*,clActiveBorder*,clInactiveBorder*,
  clAppWorkSpace*,clHighlight*,clHighlightText*,clBtnFace*,
  clBtnShadow*,clGrayText*,clBtnText*,clInactiveCaptionText*,
  clBtnHighlight*,cl3DDkShadow*,cl3DLight*,clInfoText*,clInfoBk*: W.ColorRef;

TYPE
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Graphics* = POINTER TO RECORD
    magic*   : Longint;
    handle*  : Longint;
    pointer* : Longint;
    width*   : Longint;
    height*  : Longint;
    bitsize* : Longint;
  END;

  Font* = POINTER TO RECORD
    handle*   : W.HFont;
    color*    : Longint;
    height*   : Longint;
    name*     : Name;
    style*    : Set;

    LogicFont : W.LogFont;

    PROCEDURE CreateFont;
    BEGIN
      IF handle # 0 THEN W.DeleteObject(handle); END;
      handle := W.CreateFont(
        LogicFont.lfHeight,
        LogicFont.lfWidth,
        LogicFont.lfEscapement,
        LogicFont.lfOrientation,
        LogicFont.lfWeight,
        LogicFont.lfItalic,
        LogicFont.lfUnderline,
        LogicFont.lfStrikeOut,
        LogicFont.lfCharSet,
        LogicFont.lfOutPrecision,
        LogicFont.lfClipPrecision,
        LogicFont.lfQuality,
        LogicFont.lfPitchAndFamily,
        LogicFont.lfFaceName
      );
    END CreateFont;

    PROCEDURE ClearFont;
    BEGIN
      LogicFont.lfHeight          := -height;               (*      *)
      LogicFont.lfWidth           := 0;                     (*       *)
      LogicFont.lfEscapement      := 0;                     (*  ,      X  *)
      LogicFont.lfOrientation     := 0;                     (*  ,        X  *)
      LogicFont.lfWeight          := W.FW_REGULAR;          (*       0  1000 *)
      LogicFont.lfItalic          := 0;                     (*    *)
      LogicFont.lfUnderline       := 0;                     (*    *)
      LogicFont.lfStrikeOut       := 0;                     (*    *)

      IF fsBold       IN style THEN LogicFont.lfWeight    := W.FW_BOLD; END;
      IF fsItalic     IN style THEN LogicFont.lfItalic    := 1;         END;
      IF fsUnderline  IN style THEN LogicFont.lfUnderline := 1;         END;
      IF fsStrikeOut  IN style THEN LogicFont.lfStrikeOut := 1;         END;

      LogicFont.lfCharSet         := W.DEFAULT_CHARSET;     (*    *)
      LogicFont.lfOutPrecision    := W.OUT_DEFAULT_PRECIS;  (*    *)
      LogicFont.lfClipPrecision   := W.CLIP_DEFAULT_PRECIS; (*    *)
      LogicFont.lfQuality         := W.PROOF_QUALITY;       (*    *)
      LogicFont.lfPitchAndFamily  := W.DEFAULT_PITCH;       (*       *)
      LogicFont.lfFaceName        := SYSTEM.ADR(name);      (*    *)
    END ClearFont;

    PROCEDURE & Init* (FontName : String);
    BEGIN
      height := 11;
      style  := {};
      color  := 0;
      ClearFont;
      COPY(FontName,name);
      CreateFont;
      (*handle := W.GetStockObject(W.DEFAULT_GUI_FONT);*)
    END Init;

    PROCEDURE SetName* (FontName : String);
    BEGIN
      ClearFont;
      COPY(FontName,name);
      LogicFont.lfFaceName := SYSTEM.ADR(name);
      CreateFont;
    END SetName;

    PROCEDURE SetStyle* (Style: Set);
    BEGIN
      ClearFont;
      LogicFont.lfWeight    := W.FW_NORMAL;
      LogicFont.lfItalic    := 0;
      LogicFont.lfUnderline := 0;
      LogicFont.lfStrikeOut := 0;
      IF fsBold       IN Style THEN LogicFont.lfWeight    := W.FW_BOLD; END;
      IF fsItalic     IN Style THEN LogicFont.lfItalic    := 1;         END;
      IF fsUnderline  IN Style THEN LogicFont.lfUnderline := 1;         END;
      IF fsStrikeOut  IN Style THEN LogicFont.lfStrikeOut := 1;         END;
      CreateFont;
    END SetStyle;

    PROCEDURE SetSize* (size : Integer);
    BEGIN
      ClearFont;
      LogicFont.lfHeight := -size;
      CreateFont;
    END SetSize;

  END;

  Imagelist* = POINTER TO RECORD
    width*   : Longint;
    height*  : Longint;
    bitsize* : Integer;
    count*   : Longint;
    magic*   : Longint;

    bitmap   : Longint;
    pointer  : Longint;
    BI       : W.BitmapInfo;

    PROCEDURE & Init (w,h: Longint);
    BEGIN
      width  := w;
      height := h;
      count  := 0;
      InitInfo;
    END Init;

    PROCEDURE InitInfo;
    BEGIN
      BI.bmiHeader.biSize        := SIZE(W.BitmapInfoHeader);
      BI.bmiHeader.biWidth       := 0;
      BI.bmiHeader.biHeight      := 0;
      BI.bmiHeader.biPlanes      := 1;
      BI.bmiHeader.biBitCount    := 32;
      BI.bmiHeader.biCompression := W.BI_RGB;
      bitsize := BI.bmiHeader.biBitCount DIV 8;
    END InitInfo;

    PROCEDURE LoadFromFile*(name: String);
    VAR
      bmp    : Longint;
      tmp    : Longint;
      ptr    : Longint;
      info   : W.Bitmap;
      memdc  : Longint;
      x,y    : Longint;
    BEGIN
      bmp := W.LoadImage(0,SYSTEM.ADR(name),W.IMAGE_BITMAP,0,0,W.LR_LOADFROMFILE);
      IF bmp # 0 THEN
        W.GetObject(bmp,SIZE(W.Bitmap),SYSTEM.ADR(info));
        BI.bmiHeader.biWidth  := info.bmWidth;
        BI.bmiHeader.biHeight := -info.bmHeight;
        memdc := W.CreateCompatibleDC(0);
        W.SelectObject(memdc,bmp);
        tmp := W.CreateDIBSection(0, BI, W.DIB_RGB_COLORS, ptr, 0, 0);
        W.GetDIBits(memdc, bmp, 0, info.bmHeight, ptr, BI, W.DIB_RGB_COLORS);
        SYSTEM.GET(ptr,magic);

        BI.bmiHeader.biWidth  := info.bmWidth * (info.bmHeight DIV height);
        BI.bmiHeader.biHeight := -height;

        bitmap := W.CreateDIBSection(0, BI, W.DIB_RGB_COLORS, pointer, 0, 0);
        FOR x:=0 TO info.bmHeight DIV height-1 DO
          FOR y:=0 TO height-1 DO
            SYSTEM.MOVE(
              ptr+(x*height+y)*info.bmWidth*bitsize,
              pointer+(x*info.bmWidth+y*BI.bmiHeader.biWidth)*bitsize,
              info.bmWidth*bitsize
            );
          END;
        END;
        count := BI.bmiHeader.biWidth DIV width;

        W.DeleteObject(tmp);
        W.DeleteObject(bmp);
        W.DeleteDC(memdc);
      ELSE
        count := 0;
      END;
    END LoadFromFile;

    PROCEDURE Draw*(dc,x,y,index,bgcolor,czcolor: Longint; colorize: Boolean);
    VAR
      memdc  : Longint;
      bmp    : Longint;
      ptr    : Longint;
      X,Y,c  : Longint;
    BEGIN
      IF (count > 0) & (index >= 0) & (index < count) THEN
        memdc := W.CreateCompatibleDC(0);
        BI.bmiHeader.biWidth       := width;
        BI.bmiHeader.biHeight      := -height;
        bmp := W.CreateDIBSection(0, BI, W.DIB_RGB_COLORS, ptr, 0, 0);
        FillInt(ptr,width*height*bitsize,ConvertBGRA(bgcolor));

        FOR Y:=0 TO height-1 DO
          FOR X:=0 TO width-1 DO
            SYSTEM.GET(pointer+(X+index*width+Y*width*count)*bitsize,c);
            IF c # magic THEN
              IF colorize THEN Colorize(c,czcolor) END;
              SYSTEM.PUT(ptr+(X+Y*width)*bitsize,c);
            END;
          END;
        END;

        W.SelectObject(memdc,bmp);
        W.BitBlt(dc,x,y,width,height,memdc,0,0,W.SRCCOPY);
        W.DeleteObject(bmp);
        W.DeleteDC(memdc);
      END;
    END Draw;

    PROCEDURE Destroy*;
    BEGIN
      IF bitmap # 0 THEN W.DeleteObject(bitmap) END;
    END Destroy;

  END;

PROCEDURE Frame3D*(dc,x1,y1,x2,y2,c1,c2: Longint);
VAR
  pen : W.HPen;
BEGIN
  pen := W.CreatePen(W.PS_SOLID,1,c1);
  W.SelectObject(dc, pen);
  W.MoveToEx(dc,x1,y2,NIL);
  W.LineTo(dc,x1,y1);
  W.LineTo(dc,x2,y1);
  W.DeleteObject(pen);

  pen := W.CreatePen(W.PS_SOLID,1,c2);
  W.SelectObject(dc, pen);
  W.LineTo(dc,x2,y2);
  W.LineTo(dc,x1,y2);
  W.DeleteObject(pen);

END Frame3D;

PROCEDURE RoundRect*(dc,x1,y1,x2,y2,c,r1,r2: Longint);
VAR
  pen : W.HPen;
BEGIN
  pen := W.CreatePen(W.PS_SOLID,1,c);
  W.SelectObject(dc, pen);

  W.MoveToEx(dc,x1,y2-r2,NIL);
  W.LineTo(dc,x1,y1+r2);
  W.Arc(dc,x1,y1,x1+r1*2,y1+r2*2+2,x1+r1,y1,x1,y1+r2+2);

  W.MoveToEx(dc,x1+r1,y1,NIL);
  W.LineTo(dc,x2-r1,y1);
  W.Arc(dc,x2-r1*2,y1,x2+1,y1+r2*2+1,x2+1,y1+r2+1,x2-r1-1,y1);

  W.MoveToEx(dc,x2,y1+r2,NIL);
  W.LineTo(dc,x2,y2-r2);
  W.Arc(dc,x2-r1*2+1,y2-r2*2,x2+1,y2+1,x2-r1+1,y2,x2+1,y2-r2-2);

  W.MoveToEx(dc,x2-r1,y2,NIL);
  W.LineTo(dc,x1+r1,y2);
  W.Arc(dc,x1,y2-r2*2+1,x1+r1*2+2,y2+1,x1,y2-r2,x1+r1+2,y2);

  W.DeleteObject(pen);
END RoundRect;

PROCEDURE Rectangle*(dc,x1,y1,x2,y2: Longint);
BEGIN
  W.MoveToEx(dc,x1,y1,NIL);
  W.LineTo(dc,x2,y1);
  W.LineTo(dc,x2,y2);
  W.LineTo(dc,x1,y2);
  W.LineTo(dc,x1,y1);
END Rectangle;

PROCEDURE -Sqrt(x: Real): Real;
CODE {SYSTEM.i386, SYSTEM.FPU}
  DB 0D9H, 004H, 024H	(* FLD [ESP] *)
  DB 0D9H, 0FAH	        (* FSQRT ST(0) *)
  DB 058H	        (* POP EAX *)
END Sqrt;

PROCEDURE sqrt*(x: Real): Real;
BEGIN
  RETURN Sqrt(x)
END sqrt;

PROCEDURE FillInt*(destAdr, size, filler: Longint);
CODE {SYSTEM.i386}
  MOV   EDI, destAdr[EBP]
  MOV   ECX, size[EBP]
  MOV   EAX, filler[EBP]
  TEST  ECX, 3
  JZ    ok
  PUSH  8
  INT   3
ok:
  SHR   ECX, 2
  CLD
  REP   STOSD
END FillInt;

PROCEDURE ConvertBGRA*(rgba: Longint):Longint;
BEGIN
  RETURN SYSTEM.LSH(ASH(rgba, 24), -24) * 10000H+
         SYSTEM.LSH(ASH(rgba, 16), -24) *   100H+
	 SYSTEM.LSH(ASH(rgba,  8), -24);
END ConvertBGRA;

PROCEDURE Sign*(N: Longint): Longint;
VAR
  Result: Longint;
BEGIN
  IF (N > 0) THEN
    RETURN 1
  ELSIF (N < 0) THEN
    RETURN -1
  ELSE
    RETURN 0;
  END;
END Sign;

PROCEDURE Frac*(x : Longreal): Longreal;
BEGIN
  RETURN x-ENTIER(x);
END Frac;

PROCEDURE Trunc*(x : Longreal): Longint;
BEGIN
  RETURN ENTIER(x);
END Trunc;

PROCEDURE Floor*(x : Longreal) : Longint;
VAR
  Fl: Longint;
BEGIN
  Fl:=Trunc(x);
  IF Frac(x)<0 THEN Fl := Fl-1; END;
  RETURN Fl;
END Floor;

PROCEDURE Round*(x : Longreal): Longint;
BEGIN
  IF Frac(x)>0.5 THEN
    RETURN ENTIER(x)+1;
  ELSE
    RETURN ENTIER(x);
  END;
END Round;

PROCEDURE Ceil*(x : Longreal): Longint;
VAR
  Cl: Longint;
BEGIN
  Cl:=Trunc(x);
  IF Frac(x)>0 THEN Cl:=Cl+1; END;
  RETURN Cl;
END Ceil;

PROCEDURE GetRValue*(col: Longint): Longint;
BEGIN
  RETURN (col MOD 256)
END GetRValue;

PROCEDURE GetGValue*(col: Longint): Longint;
BEGIN
  RETURN ASH(col,-8) MOD 256;
END GetGValue;

PROCEDURE GetBValue*(col: Longint): Longint;
BEGIN
  RETURN ASH(col,-16) MOD 256
END GetBValue;

PROCEDURE RGB*(red, green, blue: Longint): Longint;
BEGIN
  RETURN ASH(blue,16)+ASH(green,8)+red
END RGB;

PROCEDURE Mixed*(r, mc: Longint; c: Longreal):Longint;
VAR
  Result: Longint;
BEGIN
  (*color := dest*(255 - alpha) + src*alpha;*)
  Result:=RGB(Round(GetRValue(r) * (1-c) + GetRValue(mc) * c),
              Round(GetGValue(r) * (1-c) + GetGValue(mc) * c),
              Round(GetBValue(r) * (1-c) + GetBValue(mc) * c));
  IF Result<0 THEN Result:=0; END;
  RETURN Result;
END Mixed;

PROCEDURE Colorize*(VAR src: Longint; dest: Longint);
VAR
  l     : Longint;
  R,G,B : Longint;
BEGIN
  dest := ConvertBGRA(dest);
  l := Round(((ASH(src,-16) MOD 256) + (ASH(src,-8) MOD 256) + (src MOD 256)) DIV 3);
  R := GetRValue(dest) + l;
  G := GetGValue(dest) + l;
  B := GetBValue(dest) + l;
  IF R > 255 THEN R := 255; END;
  IF G > 255 THEN G := 255; END;
  IF B > 255 THEN B := 255; END;
  src := RGB(R, G, B);
END Colorize;

BEGIN
  clScrollBar                     := W.GetSysColor(W.COLOR_SCROLLBAR);
  clBackground                    := W.GetSysColor(W.COLOR_BACKGROUND);
  clActiveCaption                 := W.GetSysColor(W.COLOR_ACTIVECAPTION);
  clInactiveCaption               := W.GetSysColor(W.COLOR_INACTIVECAPTION);
  clMenu                          := W.GetSysColor(W.COLOR_MENU);
  clWindow                        := W.GetSysColor(W.COLOR_WINDOW);
  clWindowFrame                   := W.GetSysColor(W.COLOR_WINDOWFRAME);
  clMenuText                      := W.GetSysColor(W.COLOR_MENUTEXT);
  clWindowText                    := W.GetSysColor(W.COLOR_WINDOWTEXT);
  clCaptionText                   := W.GetSysColor(W.COLOR_CAPTIONTEXT);
  clActiveBorder                  := W.GetSysColor(W.COLOR_ACTIVEBORDER);
  clInactiveBorder                := W.GetSysColor(W.COLOR_INACTIVEBORDER);
  clAppWorkSpace                  := W.GetSysColor(W.COLOR_APPWORKSPACE);
  clHighlight                     := W.GetSysColor(W.COLOR_HIGHLIGHT);
  clHighlightText                 := W.GetSysColor(W.COLOR_HIGHLIGHTTEXT);
  clBtnFace                       := W.GetSysColor(W.COLOR_BTNFACE);
  clBtnShadow                     := W.GetSysColor(W.COLOR_BTNSHADOW);
  clGrayText                      := W.GetSysColor(W.COLOR_GRAYTEXT);
  clBtnText                       := W.GetSysColor(W.COLOR_BTNTEXT);
  clInactiveCaptionText           := W.GetSysColor(W.COLOR_INACTIVECAPTIONTEXT);
  clBtnHighlight                  := W.GetSysColor(W.COLOR_BTNHIGHLIGHT);
  cl3DDkShadow                    := W.GetSysColor(W.COLOR_3DDKSHADOW);
  cl3DLight                       := W.GetSysColor(W.COLOR_3DLIGHT);
  clInfoText                      := W.GetSysColor(W.COLOR_INFOTEXT);
  clInfoBk                        := W.GetSysColor(W.COLOR_INFOBK);
END Graphics.
